; AL.LSP 
; Written by Glen Nevill
; Bechtel Corp.
; This program creates leaders with squiggly lines.
; arrow edited by LJL - 3/21/1992
; Modified by A.Kosov, ., 1998,2002
; --------------------------------------------------

(defun c:al ( / cmde scl p1 p2 p3 p4 p5 segs a1 a2 a3 d1 );. .
        (princ "\n(C)Glen Nevill. C:AL. Arrow Leaders with squiggly lines.");kai
        ;(if (not scl) (setq scl (getreal "\nDrawing Scale: "))) ;kai
        (setq scl 1.0)                                           ;kai
        (setq p1(getpoint"\nArrow location: "))
;;;        (setq p2(getpoint"\nText location: "));kai
        (if p1 (setq p2 (getpoint p1 "\nText location: ")));kai
        (if (and p1 p2) ;add KAI
          (progn
            (setq cmde (getvar "CMDECHO"));kai
            (setvar "CMDECHO" 0)          ;kai
            (setq segs (getvar "SPLINESEGS"))
            (setvar "SPLINESEGS" 8)
            (setq a1(angle p1 p2))
            (setq a2(+ a1 (* pi 0.5)))
            (setq a3(+ a1 (* pi 1.5)))
            (setq d1(/ (distance p1 p2) 5))
            (setq p3(polar (polar p1 a1 (* 4 d1)) a2 d1))
            (setq p4(polar (polar p1 a1 d1) a3 d1))
            (setq p5(polar (polar p1 a1 (* 4.5 d1)) a2 (* 0.25 d1)))
;;;            (command "pline" p1 "w" "0" (rtos (* 0.04 scl))         ;kai
;;;                          (polar p1 (angle p1 p3) (* 0.18 scl)) "") ;kai
            (command "._PLINE" p1 "_W" "0.0" (rtos (* 1 scl))               ;kai  
                          (polar p1 (angle p1 p3) (* 3.5 scl)) "")     ;kai  
            (command "._PLINE" p1 "_W" "0.0" "0.0" p3 p4 p5 p2 "")
            (command "._PEDIT" "_L" "_S" "_X")
            (setvar "SPLINESEGS" segs)
            (command "._DTEXT")
            (if cmde (setvar "CMDECHO" cmde)) ;kai
          )
        );if p1 p2
        (prin1)
);

