;* OPEN SOURCE.     KAI-2001 (http://geol-dh.narod.ru/)
;* 
;**************** C:PER ****** PERpendicular **************
;* 
;*         (   3D)
;*            
;* 
;* Acad 15,16 ( 13-14  )
;* ()  .., 1998,2001,2003
;* .. . (413-22)5-05-10.
;* : http://geol-dh.narod.ru/   Email: ai_kosov@mail.ru
;* 
;*      ( ,      .)
;*          .
;*         .    .
;*          (, ).
;* 
;*        (),
;*    ( , , ).
;
;   :
; MES_PER
; ERROR_EPER
; RESTORE_ON_EXIT_PER
;
;* -----------------
;*  Acad PER 
;* -----------------
;
(defun C:PER ( / cmde old-error com cs e ee el c1 c2 str d cm)
  ;*    (Language support)
  (setq lang 2);[1  2] 2-  -  (  )
               ;          1- English language
  
  ;.   ,     : ACAD.LSP, *.MNL, ...
  ;(Set variable for English support in ACAD.LSP, *.MNL, ...)
  (if (and language$- (or (= language$- 1)(= language$- 2)))
    (setq lang language$-)
  )
  ;*    2 
  ;*      2-  3-  ()!
  (setq mlst '(
    (0 "Draw PERPENDICULAR line." "  ().")
    (1 "Specify perpendicular line START point" "   ")
    (2 "Select object for END point of line [Osnap=PER]" "     [Osnap=PER]")
    (3 "Specify perpendicular LENGTH" "  ")
    (4 "Can't changed object length on locked layer." "      .")
    (5 "Specify point to move perpendicular" "    ")
    (6 "Can't move object on locked layer." "     .")
  ));end of list ** mlst ** ( )
  ;
  ; ----------------------------------------------
  ;       2 
  ; ----------------------------------------------
  (defun MES_PER (num / mes2)
    ;num  =  (int)   mlst
    (if (and mlst (setq mes2 (nth num mlst))); = '(num "str_eng" str2_rus")
      (setq mes2 (nth lang mes2));    
    )  
    (if (not mes2);      
      (progn
        (alert (strcat (itoa num) "\n" "Message not found."))
        (setq mes2 "_?_")
      )
    )
    mes2
  );end of **** MES_EE *****
  ;
  (defun ERROR_PER (errnumber)              ; If an error (such as CTRL-C) occurs
    (if (not (member errnumber '("Function cancelled" "console break" "quit / exit abort")))
      (princ (strcat "\nERROR in program PER: " errnumber))
    )
    (RESTORE_ON_EXIT_PER);     
    (prin1)
  ); end of ** ERROR_PER **
  ;
  ; -------------------------------------------
  ;     
  ; -------------------------------------------
  (defun RESTORE_ON_EXIT_PER ()
    (if old-error (setq *error* old-error)) ; Restore old *error* handler
    (command "._UNDO" "_END")         ;   
    (if cmde (setvar "CMDECHO" cmde)); Restore cmdecho value
    (prin1)
  ) ;end of ******* RESTORE_ON_EXIT_PER ********
  ;
  (setq cmde (getvar "CMDECHO")    ; save current setting of cmdecho
        old-error  *error*         ; save current error function
        *error* ERROR_PER            ; new error function
  )
  (setvar "CMDECHO" 0)
  (command "._UNDO" "_BEGIN")
  ;       F1
  (if (findfile "KAI-2001-FW.HLP")
    (setfunhelp (strcat "C:" "PER") "KAI-2001-FW.HLP" "PER")
    (princ (strcat "\n KAI-2001-FW.HLP"  "  " (MES_EE 11)));11="Help file not found."
  )
  (princ (strcat "\n(C)KAI (FA). C:PER. " (MES_PER 0)));0="Draw PERPENDICULAR line."
  (setvar "CMDECHO" 0)
  (setq com (getvar "LUPREC"))
  (setq cs (getpoint (strcat "\n" (MES_PER 1) ": ")));1="Specify perpendicular line START point"
  (if cs
    (progn
      (princ (strcat "\n " (MES_PER 2) ": "));2="Select object for END point of line [Osnap=PER]"
      (setq e (entlast))
      (command "._LINE" cs "PER" pause "")
      (setq ee (entlast))
      (if (not (eq e ee))
        (progn
          (setq el (entget ee))
          (setq c1 (cdr (assoc 10 el)));start point of line
          (setq c2 (cdr (assoc 11 el)));end point
          (if (not (equal (caddr c1) (caddr c2) 0.000000001))
            (setq str (strcat " [XYZ]"))
            (setq str "")
          )
          (setq d (getdist (strcat "\n " (MES_PER 3) str " <";3="Specify perpendicular LENGTH"
                                   (rtos (distance c1 c2) 2 com)
                                   ">: ")))
          (setq el (tblsearch "LAYER" (cdr (assoc 8 (entget ee)))))
          (if d
            (progn
              (if (not (zerop (logand (cdr (assoc 70 el)) 4)))
                (alert (MES_PER 4));4="Can't changed object length on locked layer."
                (command "._LENGTHEN" "_T" d (list ee c1) "");in 3D
              )
            )
          )
          (setq cm (getpoint (getvar "LASTPOINT") (strcat "\n  " (MES_PER 5) ": ")));5="Specify point to move line"
          (if cm
            (progn
              (if (not (zerop (logand (cdr (assoc 70 el)) 4)))
                (alert (MES_PER 6));6="Can't move object on locked layer."
                (if (/= (getvar "WORLDUCS") 1)
                  (command "._MOVE" ee "" (trans (cdr (assoc 11 (entget ee))) ee 1) cm)
                  (command "._MOVE" ee "" (cdr (assoc 11 (entget ee))) cm)
                )
              )
            )
          );if cm
        )
      );if
    )
  );if cs
  ;     
  (princ "* End C:PER *")
  (RESTORE_ON_EXIT_PER);  ,  
  (prin1);  
);end ****C:PER****