//  SETUP1.DCL
//  
//    SETUP1.LSP
//  
//   Acad 15, 16
//  (C)KAI, Kosov Alexander, 2004, Magadan, Russia
//   : http://geol-dh.narod.ru/                  ()
//  Site : http://geol-dh.narod.ru/en_index.html     (English)
// ***************** ENGLISH *********************************
settings_SETUP1 : dialog {
    label = "Installation applications into current Acad (and into current Acad profile)";
    : boxed_column {
        label = "Set installation folder:";
        : row {
            alignment = left;
            fixed_width = true;
            : edit_box {
                label = "Path:";
                key = "-setup_folder";
                edit_width = 80;
                edit_limit = 250;
            }
            : button {
                label = "< Browse >";
                key = "-setup_folder_but";
                fixed_width = true;
            }
        }
    }

    : boxed_column {
        label = "Copy Acad templates *.DWT (if any):";
        : row {
            fixed_width = true;
            : toggle {
                label = "Send copy to:";
                key = "-setup_copy_templ";
            }
            : text {
                fixed_width = true;
                key = "-setup_copy_templ_dir";
                width = 90;
            }
        }
    }
    : boxed_column {
        label = "Arrange acad search path:";
        : row {
            fixed_width = true;
            : radio_row {
                fixed_width = true;
                : radio_button {
                    label = "Move application path to the TOP of paths";
                    key = "-setup_use_pgp1";
                }
                : radio_button {
                    label = "Move application path to the BOTTOM of paths";
                    key = "-setup_use_pgp2";
                }
            }
        }
    }
    : row {    
        fixed_width = true;
        alignment = centered;
        : row {
            : boxed_column {
                label = "Select menu(s) to load (use Ctrl key to select a few):";
                fixed_width = true;
                : list_box {
                    fixed_width = true;
                    key = "-setup_inst_menu";
                    width = 55;
                    fixed_height = 11;
                    multiple_select = true;
                }
                : text {
                    key = "-setup_inst_menu_txt";
                    width = 55;
                }
            }
        }
        : boxed_column {
            fixed_width = true;
            : image {
                key          = "-setup_image";
                height       = 10;
                aspect_ratio = 1.4;
                color        = 0;
            }
        }
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label = "Begin installation";
            key = "accept";
            is_cancel = false;
            alignment = centered;
            fixed_width = true;
        }
        : button {
            label = "Cancel";
            key = "cancel";
            is_cancel = true;
            alignment = centered;
            fixed_width = true;
        }
        : button {
            label = "Help";
            key = "help";
            alignment = centered;
            fixed_width = true;
        }
    }
    errtile;
    spacer_1;
    : text {
        label = "Thanks:  1992-2004 Robert McNeel & Associates. All rights reserved. (DOSLib 6.1, www.mcneel.com)";
        edit_width = 80;
    }
    : text {
        label = " Kosov Alexander, 2004, Magadan, http:\\geol-dh.narod.ru";
        edit_width = 80;
    }
}
// ***************** RUSSIAN *************************
settings_SETUP1_RUS : dialog {
    label = "    Acad (    Acad)";
    : boxed_column {
        label = "  :";
        : row {
            alignment = left;
            fixed_width = true;
            : edit_box {
                label = ":";
                key = "-setup_folder";
                edit_width = 80;
                edit_limit = 250;
            }
            : button {
                label = "";
                key = "-setup_folder_but";
                fixed_width = true;
            }
        }
    }

    : boxed_column {
        label = "   *.DWT ( ):";
        : row {
            fixed_width = true;
            : toggle {
                label = " :";
                key = "-setup_copy_templ";
            }
            : text {
                fixed_width = true;
                key = "-setup_copy_templ_dir";
                width = 90;
            }
        }
    }
    : boxed_column {
        label = "   Acad:";
        : row {
            fixed_width = true;
            : radio_row {
                fixed_width = true;
                : radio_button {
                    label = "     ";
                    key = "-setup_use_pgp1";
                }
                : radio_button {
                    label = "     ";
                    key = "-setup_use_pgp2";
                }
            }
        }
    }
    : row {    
        fixed_width = true;
        alignment = centered;
        : row {
            : boxed_column {
                label = "    (Ctrl - ):";
                fixed_width = true;
                : list_box {
                    fixed_width = true;
                    key = "-setup_inst_menu";
                    width = 55;
                    fixed_height = 11;
                    multiple_select = true;
                }
                : text {
                    key = "-setup_inst_menu_txt";
                    width = 55;
                }
            }
        }
        : boxed_column {
            fixed_width = true;
            : image {
                key          = "-setup_image";
                height       = 10;
                aspect_ratio = 1.4;
                color        = 0;
            }
        }
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label = " ";
            key = "accept";
            is_cancel = false;
            alignment = centered;
            fixed_width = true;
        }
        : button {
            label = "Cancel";
            key = "cancel";
            is_cancel = true;
            alignment = centered;
            fixed_width = true;
        }
        : button {
            label = "Help";
            key = "help";
            alignment = centered;
            fixed_width = true;
        }
    }
    errtile;
    spacer_1;
    : text {
        label = "Thanks:  1992-2004 Robert McNeel & Associates. All rights reserved. (DOSLib 6.1, www.mcneel.com)";
        edit_width = 80;
    }
    : text {
        label = " Kosov Alexander, 2004, Magadan, http:\\geol-dh.narod.ru";
        edit_width = 80;
    }
}
